// 
// gettoken.h
//
#ifndef GETTOKEN_H
#define GETTOKEN_H
#include <iostream>
#include <algorithm>
#include <string>
#include <cctype>

using namespace std;

enum tokenType { Value, Plus, Minus, Mult, Divide, Assign,
                 LParen, RParen, Symbol, Invalid, Start };
typedef tokenType TokenType;

class Token {
    string symbol;
    double value;
    TokenType type;

public:
    // RXgN^
    Token () {};
    Token (double v, TokenType t) {
        value = v;
        type = t;
    };
    Token (double v) {
        value = v;
        type = Value;
    };
    Token (string s) {
        symbol = s;
        type = Symbol;
    };
    Token (TokenType t) {
        value = 0.0;
        type = t;
    };
    string getSymbol() { return symbol; };
    double getValue() { return value; };
    TokenType getType() { return type; };
    bool isStartToken();
    void printToken();
};

Token *getToken(string s);
bool isStartToken(TokenType tt);

extern     Token prevTok;

#endif
